<template>
<div>
  <div class="top-nav">
    <router-link class="active" to="/dashboard">Home</router-link>
    <div class="top-nav-right">
      <router-link to="/account">Account</router-link>
      <router-link to="/logout">Logout</router-link>
    </div>
  </div>
  <br><br>
  <div>
    <li v-for="incident in incidents" :key="incident">
      <b-card class="bg-green" text-variant="white">
        <h5> {{ incident.name }} - {{ incident.components[0].name }} affected </h5>
      </b-card>
      <b-card class="bg-green" bg-variant="white" text-variant="dark">
        <b-card-text>
          <span class="badge badge-pill badge-info even-larger-badge">{{ incident.status }}
          </span>
          <b>{{ incident.started | formatDate}}</b> - {{ incident.updates[0].message }}
        </b-card-text>
      </b-card>
      <br>
    </li>
  </div>
  <div>
    <b-card class="bg-dark" text-variant="white" title="SERVICES">
      <b-card-text> Below are the current services of the user. </b-card-text>
    </b-card>
  </div>
  <li v-for="component in components" :key="component">
    <b-card class="bg-dark" bg-variant="white" text-variant="dark">
      <span class="badge badge-success even-larger-badge">{{ status }} </span>
      <b class="comp"> {{ component.name.toUpperCase() }} </b>
      <br>
      <b-button class="btn-info" size="sm" variant="info" v-on:click="goTo(component.id)">
        More Info
      </b-button>
    </b-card>
  </li>
  <div>
    <b-button variant="primary" href="/complex">Add complex healthcheck</b-button>
    <b-button variant="primary" href="/basic">Add basic healthcheck</b-button>
  </div>
</div>
</template>

<script>
import axios from 'axios';

export const SERVER_API_URL = process.env.SERVER_API_URL || '';

export default {
  name: 'Dashboard',
  data() {
    return {
      msg: '',
      components: [{}],
      incidents: [{}],
      status: '',
      ref: '',
    };
  },
  methods: {
    logged() {
      if (!localStorage.getItem('user-token')) {
        this.$router.push('/');
      }
    },
    getComponents() {
      const path = `${SERVER_API_URL}/v1.0/components/`;
      axios.get(path)
        .then((res) => {
          if (res.status === 200) {
            this.components = res.data;
            this.ref = `/component?id=${this.components.id}`;
            console.log(this.components);
          }
        })
        .catch((error) => {
          console.error(error);
        });
    },
    getComponentsState() {
      const path = `${SERVER_API_URL}/v1.0/statecomponents/`;
      axios.get(path)
        .then((res) => {
          if (res.status === 200) {
            this.status = res.data[1].status;
          }
        })
        .catch((error) => {
          console.error(error);
        });
    },
    getIncidents() {
      const path = `${SERVER_API_URL}/v1.0/incidents/`;
      axios.get(path)
        .then((res) => {
          if (res.status === 200) {
            this.incidents = res.data;
          }
        })
        .catch((error) => {
          console.error(error);
        });
    },
    goTo(id) {
      this.ref = `/component?id=${id}`;
      this.$router.push(this.ref);
    },
  },
  created() {
    this.logged();
    this.getComponents();
    this.getComponentsState();
    this.getIncidents();
  },
};

</script>

<style>
/* Add a black background color to the top navigation */
.top-nav {
  margin-top: 0;
  background-color: #333;
  overflow: hidden;
}

/* Style the links inside the navigation bar */
.top-nav a {
  float: left;
  color: #f2f2f2;
  text-align: center;
  padding: 14px 16px;
  text-decoration: none;
  font-size: 17px;
}

/* Change the color of links on hover */
.top-nav a:hover {
  background-color: #ddd;
  color: black;
}

/* Add a color to the active/current link */
.top-nav a.active {
  background-color: #04AA6D;
  color: white;
}

/* Right-aligned section inside the top navigation */
.top-nav-right {
  float: right;
}

div {
  margin-left: 0px;
}

.btn {
  float: right;
  margin-top: 1rem;
  margin-bottom: 1rem;
  margin-right: 1.5rem;
  text-transform: unset;
}

.badge.even-larger-badge {
  font-size: 0.9em;
  margin-right: 0.5rem;
  margin-bottom: 0.5rem;
}

.card.bg-green {
  text-align: left;
  margin: 0 20px 0px;
  padding: 10px 0px 10px;
  width: auto;
  height: 70px;
  box-shadow: 0 8px 26px -4px rgba(0,0,0,0.15);
  border-radius: 5px;
  background-color: #04AA6D;
}

.btn-info {
  float: left;
}

b.comp {
  font-size: large;
}

.card.bg-dark {
  text-align: left;
  margin: 0 20px 0px;
  padding: 10px 40px 0px;
  width: auto;
  height: 150px;
  box-shadow: 0 8px 26px -4px rgba(0,0,0,0.15);
  border-radius: 5px;
  background: var(--white);
}

p {
  margin: auto;
  text-align: left;
}

</style>
